#ifndef CPP_LAYOUTER_BOOPSIGADGETS_H
#define CPP_LAYOUTER_BOOPSIGADGETS_H

// Die Layouterklassen fr die verschiedenen Boopsi Gadgets
//
// Autor: Jochen Becher
//
// Historie:
// Version 1.0 am 9. Juni 94

#ifndef CPP_BOOPSI_GADGETS_H
#include <classes/BOOPSI/gadgets.h>
#endif

#ifndef CPP_LAYOUTER_LAYOUTER_H
#include <classes/layouter/layouter.h>
#endif

#ifndef CPP_LAYOUTER_GADGETS_H
#include <classes/layouter/gadgets.h>
#endif

class LBButtonC : public BButtonC, public LGButtonC {
public:
	LBButtonC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBButtonC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BButtonC::setTop(t); };
	VOID setLeft(WORD l) { BButtonC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BButtonC::top(); };
	WORD left() const { return BButtonC::left(); };
	WORD width() const { return BButtonC::width(); };
	WORD height() const { return BButtonC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BButtonC::topBorder(); };
	WORD leftBorder() const { return BButtonC::leftBorder(); };
	WORD rightBorder() const { return BButtonC::rightBorder(); };
	WORD bottomBorder() const { return BButtonC::bottomBorder(); };
	BOOL disable(BOOL value) { return BButtonC::disable(value); };
	BOOL isDisabled() const { return BButtonC::isDisabled(); };
	BOOL activate(BOOL value) { return BButtonC::activate(value); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBFrButtonC : public BFrbuttonC, public LGButtonC {
public:
	LBFrButtonC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBFrButtonC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BFrbuttonC::setTop(t); };
	VOID setLeft(WORD l) { BFrbuttonC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BFrbuttonC::top(); };
	WORD left() const { return BFrbuttonC::left(); };
	WORD width() const { return BFrbuttonC::width(); };
	WORD height() const { return BFrbuttonC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BFrbuttonC::topBorder(); };
	WORD leftBorder() const { return BFrbuttonC::leftBorder(); };
	WORD rightBorder() const { return BFrbuttonC::rightBorder(); };
	WORD bottomBorder() const { return BFrbuttonC::bottomBorder(); };
	BOOL disable(BOOL value) { return BFrbuttonC::disable(value); };
	BOOL isDisabled() const { return BFrbuttonC::isDisabled(); };
	BOOL activate(BOOL value) { return BFrbuttonC::activate(value); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBIButtonC : public BIButtonC, public LGButtonC {
public:
	LBIButtonC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBIButtonC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BIButtonC::setTop(t); };
	VOID setLeft(WORD l) { BIButtonC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BIButtonC::top(); };
	WORD left() const { return BIButtonC::left(); };
	WORD width() const { return BIButtonC::width(); };
	WORD height() const { return BIButtonC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BIButtonC::topBorder(); };
	WORD leftBorder() const { return BIButtonC::leftBorder(); };
	WORD rightBorder() const { return BIButtonC::rightBorder(); };
	WORD bottomBorder() const { return BIButtonC::bottomBorder(); };
	BOOL disable(BOOL value) { return BIButtonC::disable(value); };
	BOOL isDisabled() const { return BIButtonC::isDisabled(); };
	BOOL activate(BOOL value) { return BIButtonC::activate(value); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBStringC : public BStringC, public LGStringC {
public:
	LBStringC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBStringC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BStringC::setTop(t); };
	VOID setLeft(WORD l) { BStringC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BStringC::top(); };
	WORD left() const { return BStringC::left(); };
	WORD width() const { return BStringC::width(); };
	WORD height() const { return BStringC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BStringC::topBorder(); };
	WORD leftBorder() const { return BStringC::leftBorder(); };
	WORD rightBorder() const { return BStringC::rightBorder(); };
	WORD bottomBorder() const { return BStringC::bottomBorder(); };
	BOOL disable(BOOL value) { return BStringC::disable(value); };
	BOOL isDisabled() const { return BStringC::isDisabled(); };
	BOOL activate(BOOL value) { return BStringC::activate(value); };
	VOID set(STRPTR s) { BStringC::set(s); };
	STRPTR get() { return BStringC::get(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBIntegerC : public BIntegerC, public LGIntegerC {
public:
	LBIntegerC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBIntegerC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BIntegerC::setTop(t); };
	VOID setLeft(WORD l) { BIntegerC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BIntegerC::top(); };
	WORD left() const { return BIntegerC::left(); };
	WORD width() const { return BIntegerC::width(); };
	WORD height() const { return BIntegerC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BIntegerC::topBorder(); };
	WORD leftBorder() const { return BIntegerC::leftBorder(); };
	WORD rightBorder() const { return BIntegerC::rightBorder(); };
	WORD bottomBorder() const { return BIntegerC::bottomBorder(); };
	BOOL disable(BOOL value) { return BIntegerC::disable(value); };
	BOOL isDisabled() const { return BIntegerC::isDisabled(); };
	BOOL activate(BOOL value) { return BIntegerC::activate(value); };
	VOID set(LONG s) { BIntegerC::set(s); };
	LONG get() { return BIntegerC::get(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBCheckboxC : public BCheckboxC, public LGCheckboxC {
public:
	LBCheckboxC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBCheckboxC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BCheckboxC::setTop(t); };
	VOID setLeft(WORD l) { BCheckboxC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BCheckboxC::top(); };
	WORD left() const { return BCheckboxC::left(); };
	WORD width() const { return BCheckboxC::width(); };
	WORD height() const { return BCheckboxC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BCheckboxC::topBorder(); };
	WORD leftBorder() const { return BCheckboxC::leftBorder(); };
	WORD rightBorder() const { return BCheckboxC::rightBorder(); };
	WORD bottomBorder() const { return BCheckboxC::bottomBorder(); };
	BOOL disable(BOOL value) { return BCheckboxC::disable(value); };
	BOOL isDisabled() const { return BCheckboxC::isDisabled(); };
	BOOL activate(BOOL value) { return BCheckboxC::activate(value); };
	VOID check(BOOL v) { BCheckboxC::check(v); };
	BOOL checked() { return BCheckboxC::checked(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBRadioC : public BRadioC, public LGRadioC {
public:
	LBRadioC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBRadioC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BRadioC::setTop(t); };
	VOID setLeft(WORD l) { BRadioC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BRadioC::top(); };
	WORD left() const { return BRadioC::left(); };
	WORD width() const { return BRadioC::width(); };
	WORD height() const { return BRadioC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BRadioC::topBorder(); };
	WORD leftBorder() const { return BRadioC::leftBorder(); };
	WORD rightBorder() const { return BRadioC::rightBorder(); };
	WORD bottomBorder() const { return BRadioC::bottomBorder(); };
	BOOL disable(BOOL value) { return BRadioC::disable(value); };
	BOOL isDisabled() const { return BRadioC::isDisabled(); };
	BOOL activate(BOOL value) { return BRadioC::activate(value); };
	VOID select(ULONG l) { BRadioC::select(l); };
	ULONG selected() { return BRadioC::selected(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBCycleC : public BCycleC, public LGCycleC {
public:
	LBCycleC(GadgetEventC *, WindowC &w, stringarray &,
		WORD Width, WORD Height, Tag tag1type, ...);
	LBCycleC(GadgetEventC *, WindowC &w, stringarray &,
		WORD Width, WORD Height, struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BCycleC::setTop(t); };
	VOID setLeft(WORD l) { BCycleC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BCycleC::top(); };
	WORD left() const { return BCycleC::left(); };
	WORD width() const { return BCycleC::width(); };
	WORD height() const { return BCycleC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BCycleC::topBorder(); };
	WORD leftBorder() const { return BCycleC::leftBorder(); };
	WORD rightBorder() const { return BCycleC::rightBorder(); };
	WORD bottomBorder() const { return BCycleC::bottomBorder(); };
	BOOL disable(BOOL value) { return BCycleC::disable(value); };
	BOOL isDisabled() const { return BCycleC::isDisabled(); };
	BOOL activate(BOOL value) { return BCycleC::activate(value); };
	VOID select(ULONG l) { BCycleC::select(l); };
	ULONG selected() { return BCycleC::selected(); };
	VOID setLabels(STRPTR *l) { BCycleC::setLabels(l); };
	VOID setLabels(STRPTR label1, ...) { BCycleC::setLabels(&label1); };
	STRPTR *getLabels() { return BCycleC::getLabels(); };
	ULONG labelsCount() { return BCycleC::labelsCount(); };
	UWORD addLabel(STRPTR label) { return BCycleC::addLabel(label); };
	VOID remLabel(UWORD count) { BCycleC::remLabel(count); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBSliderC : public BSliderC, public LGSliderC {
public:
	LBSliderC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBSliderC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BSliderC::setTop(t); };
	VOID setLeft(WORD l) { BSliderC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BSliderC::top(); };
	WORD left() const { return BSliderC::left(); };
	WORD width() const { return BSliderC::width(); };
	WORD height() const { return BSliderC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BSliderC::topBorder(); };
	WORD leftBorder() const { return BSliderC::leftBorder(); };
	WORD rightBorder() const { return BSliderC::rightBorder(); };
	WORD bottomBorder() const { return BSliderC::bottomBorder(); };
	BOOL disable(BOOL value) { return BSliderC::disable(value); };
	BOOL isDisabled() const { return BSliderC::isDisabled(); };
	BOOL activate(BOOL value) { return BSliderC::activate(value); };
	VOID setMin(UWORD m) { BSliderC::setMin(m); };
	VOID setMax(UWORD m) { BSliderC::setMax(m); };
	VOID setLevel(UWORD l) { BSliderC::setLevel(l); };
	UWORD min() { return BSliderC::min(); };
	UWORD max() { return BSliderC::max(); };
	UWORD level() { return BSliderC::level(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBScrollerC : public BScrollerC, public LGScrollerC {
public:
	LBScrollerC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBScrollerC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BScrollerC::setTop(t); };
	VOID setLeft(WORD l) { BScrollerC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BScrollerC::top(); };
	WORD left() const { return BScrollerC::left(); };
	WORD width() const { return BScrollerC::width(); };
	WORD height() const { return BScrollerC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BScrollerC::topBorder(); };
	WORD leftBorder() const { return BScrollerC::leftBorder(); };
	WORD rightBorder() const { return BScrollerC::rightBorder(); };
	WORD bottomBorder() const { return BScrollerC::bottomBorder(); };
	BOOL disable(BOOL value) { return BScrollerC::disable(value); };
	BOOL isDisabled() const { return BScrollerC::isDisabled(); };
	BOOL activate(BOOL value) { return BScrollerC::activate(value); };
	VOID setPot(UWORD p) { BScrollerC::setPot(p); };
	VOID setTotal(UWORD t) { BScrollerC::setTotal(t); };
	VOID setVisible(UWORD v) { BScrollerC::setVisible(v); };
	UWORD pot() { return BScrollerC::pot(); };
	UWORD total() { return BScrollerC::total(); };
	UWORD visible() { return BScrollerC::visible(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBArrowScrollerC : public BArrowScrollerC, public LGScrollerC {
public:
	LBArrowScrollerC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBArrowScrollerC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BArrowScrollerC::setTop(t); };
	VOID setLeft(WORD l) { BArrowScrollerC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BArrowScrollerC::top(); };
	WORD left() const { return BArrowScrollerC::left(); };
	WORD width() const { return BArrowScrollerC::width(); };
	WORD height() const { return BArrowScrollerC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BArrowScrollerC::topBorder(); };
	WORD leftBorder() const { return BArrowScrollerC::leftBorder(); };
	WORD rightBorder() const { return BArrowScrollerC::rightBorder(); };
	WORD bottomBorder() const { return BArrowScrollerC::bottomBorder(); };
	BOOL disable(BOOL value) { return BArrowScrollerC::disable(value); };
	BOOL isDisabled() const { return BArrowScrollerC::isDisabled(); };
	BOOL activate(BOOL value) { return BArrowScrollerC::activate(value); };
	VOID setPot(UWORD p) { BArrowScrollerC::setPot(p); };
	VOID setTotal(UWORD t) { BArrowScrollerC::setTotal(t); };
	VOID setVisible(UWORD v) { BArrowScrollerC::setVisible(v); };
	UWORD pot() { return BArrowScrollerC::pot(); };
	UWORD total() { return BArrowScrollerC::total(); };
	UWORD visible() { return BArrowScrollerC::visible(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBListC : public BListC, public LGListviewC {
public:
	LBListC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBListC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BListC::setTop(t); };
	VOID setLeft(WORD l) { BListC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BListC::top(); };
	WORD left() const { return BListC::left(); };
	WORD width() const { return BListC::width(); };
	WORD height() const { return BListC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BListC::topBorder(); };
	WORD leftBorder() const { return BListC::leftBorder(); };
	WORD rightBorder() const { return BListC::rightBorder(); };
	WORD bottomBorder() const { return BListC::bottomBorder(); };
	BOOL disable(BOOL value) { return BListC::disable(value); };
	BOOL isDisabled() const { return BListC::isDisabled(); };
	BOOL activate(BOOL value) { return BListC::activate(value); };
	VOID select(ULONG l) { BListC::select(l); };
	ULONG selected() { return BListC::selected(); };
	VOID clearSelection() { BListC::clearSelection(); };
	VOID setList(EListC *h) { BListC::setList(h); };
	EListC *getList() { return BListC::getList(); };
	VOID detachList() { BListC::detachList(); };
	VOID attachList() { BListC::attachList(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBListviewC : public BListviewC, public LGListviewC {
public:
	LBListviewC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBListviewC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BListviewC::setTop(t); };
	VOID setLeft(WORD l) { BListviewC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BListviewC::top(); };
	WORD left() const { return BListviewC::left(); };
	WORD width() const { return BListviewC::width(); };
	WORD height() const { return BListviewC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BListviewC::topBorder(); };
	WORD leftBorder() const { return BListviewC::leftBorder(); };
	WORD rightBorder() const { return BListviewC::rightBorder(); };
	WORD bottomBorder() const { return BListviewC::bottomBorder(); };
	BOOL disable(BOOL value) { return BListviewC::disable(value); };
	BOOL isDisabled() const { return BListviewC::isDisabled(); };
	BOOL activate(BOOL value) { return BListviewC::activate(value); };
	VOID select(ULONG l) { BListviewC::select(l); };
	ULONG selected() { return BListviewC::selected(); };
	VOID clearSelection() { BListviewC::clearSelection(); };
	VOID setList(EListC *h) { BListviewC::setList(h); };
	EListC *getList() { return BListviewC::getList(); };
	VOID detachList() { BListviewC::detachList(); };
	VOID attachList() { BListviewC::attachList(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBTextC : public BTextC, public LGTextC {
public:
	LBTextC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBTextC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BTextC::setTop(t); };
	VOID setLeft(WORD l) { BTextC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BTextC::top(); };
	WORD left() const { return BTextC::left(); };
	WORD width() const { return BTextC::width(); };
	WORD height() const { return BTextC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BTextC::topBorder(); };
	WORD leftBorder() const { return BTextC::leftBorder(); };
	WORD rightBorder() const { return BTextC::rightBorder(); };
	WORD bottomBorder() const { return BTextC::bottomBorder(); };
	BOOL disable(BOOL value) { return BTextC::disable(value); };
	BOOL isDisabled() const { return BTextC::isDisabled(); };
	BOOL activate(BOOL value) { return BTextC::activate(value); };
	VOID set(STRPTR s) { BTextC::set(s); };
	STRPTR get() { return BTextC::get(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBNumberC : public BNumberC, public LGNumberC {
public:
	LBNumberC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBNumberC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BNumberC::setTop(t); };
	VOID setLeft(WORD l) { BNumberC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BNumberC::top(); };
	WORD left() const { return BNumberC::left(); };
	WORD width() const { return BNumberC::width(); };
	WORD height() const { return BNumberC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BNumberC::topBorder(); };
	WORD leftBorder() const { return BNumberC::leftBorder(); };
	WORD rightBorder() const { return BNumberC::rightBorder(); };
	WORD bottomBorder() const { return BNumberC::bottomBorder(); };
	BOOL disable(BOOL value) { return BNumberC::disable(value); };
	BOOL isDisabled() const { return BNumberC::isDisabled(); };
	BOOL activate(BOOL value) { return BNumberC::activate(value); };
	VOID set(LONG l) { BNumberC::set(l); };
	LONG get() { return BNumberC::get(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBWBIconDropC : public BWBIconDropC, public LayoutC {
public:
	LBWBIconDropC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBWBIconDropC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BWBIconDropC::setTop(t); };
	VOID setLeft(WORD l) { BWBIconDropC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BWBIconDropC::top(); };
	WORD left() const { return BWBIconDropC::left(); };
	WORD width() const { return BWBIconDropC::width(); };
	WORD height() const { return BWBIconDropC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BWBIconDropC::topBorder(); };
	WORD leftBorder() const { return BWBIconDropC::leftBorder(); };
	WORD rightBorder() const { return BWBIconDropC::rightBorder(); };
	WORD bottomBorder() const { return BWBIconDropC::bottomBorder(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LBSplitviewC : public BSplitviewC, public LayoutC {
public:
	LBSplitviewC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		Tag tag1type, ...);
	LBSplitviewC(GadgetEventC *, WindowC &w, WORD Width, WORD Height,
		struct TagItem *tags = NULL);
	BOOL layoutWidth();
	BOOL layoutHeight();
	VOID setTop(WORD t) { BSplitviewC::setTop(t); };
	VOID setLeft(WORD l) { BSplitviewC::setLeft(l); };
	VOID setWidth(WORD w);
	VOID setHeight(WORD h);
	WORD top() const { return BSplitviewC::top(); };
	WORD left() const { return BSplitviewC::left(); };
	WORD width() const { return BSplitviewC::width(); };
	WORD height() const { return BSplitviewC::height(); };
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
	WORD topBorder() const { return BSplitviewC::topBorder(); };
	WORD leftBorder() const { return BSplitviewC::leftBorder(); };
	WORD rightBorder() const { return BSplitviewC::rightBorder(); };
	WORD bottomBorder() const { return BSplitviewC::bottomBorder(); };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class SplitviewHookC : public GeometryHookC {
public:
	SplitviewHookC(GeometryC &splitview);
	ULONG layout(GeometryC *, struct LayoutParamPkt *);
private:
	GeometryC &splitviewGeo;
};

#endif
