#ifndef CPP_LAYOUTER_GADTOOLS_H
#define CPP_LAYOUTER_GADTOOLS_H

// Layouter fr GadTools Gadgets
//
// Autor: Jochen Becher
//
// Historie:
// Version 1.0 am 8. Mrz 94

#ifndef CPP_LIBRARIES_GADTOOLS_H
#include <classes/libraries/gadtools.h>
#endif

#ifndef CPP_LAYOUTER_LAYOUTER_H
#include <classes/layouter/layouter.h>
#endif

#ifndef CPP_LAYOUTER_GADGETS_H
#include <classes/layouter/gadgets.h>
#endif

class LGTButtonC : public GTButtonC, public LGButtonC {
public:
	LGTButtonC(GadgetEventC *,
		STRPTR label,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTButtonC(GadgetEventC *,
		STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTButtonC::rebuild(prev); };
	VOID erase(WindowC *w) { GTButtonC::erase(w); };
	VOID setLeft(WORD left) { GTButtonC::setLeft(left); };
	VOID setTop(WORD top) { GTButtonC::setTop(top); };
	VOID setWidth(WORD width) { GTButtonC::setWidth(width); };
	VOID setHeight(WORD height) { GTButtonC::setHeight(height); };
	WORD left() const { return GTButtonC::left(); };
	WORD top() const { return GTButtonC::top(); };
	WORD width() const { return GTButtonC::width(); };
	WORD height() const { return GTButtonC::height(); };
	WORD leftBorder() const { return GTButtonC::leftBorder(); };
	WORD topBorder() const { return GTButtonC::topBorder(); };
	WORD rightBorder() const { return GTButtonC::rightBorder(); };
	WORD bottomBorder() const { return GTButtonC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTButtonC::disable(value); };
	BOOL isDisabled() const { return GTButtonC::isDisabled(); };
	BOOL activate(BOOL value) { return GTButtonC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTButtonC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTButtonC::setDefTextAttr(t); };
	ULONG idcmp() { return GTButtonC::idcmp(); };
	VOID setInnerBorderWidth(WORD w) { innerBorderWidth = w; };
	VOID setInnerBorderHeight(WORD h) { innerBorderHeight = h; };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	WORD innerBorderHeight;
	WORD innerBorderWidth;
	BOOL aWidth;
	BOOL aHeight;
};

class LGTStringC : public GTStringC, public LGStringC {
public:
	LGTStringC(GadgetEventC *,
		WORD columns = LAYOUT_AUTOSIZE, STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTStringC(GadgetEventC *,
		WORD columns, STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTStringC::rebuild(prev); };
	VOID erase(WindowC *w) { GTStringC::erase(w); };
	VOID setLeft(WORD left) { GTStringC::setLeft(left); };
	VOID setTop(WORD top) { GTStringC::setTop(top); };
	VOID setWidth(WORD width) { GTStringC::setWidth(width); };
	VOID setHeight(WORD height) { GTStringC::setHeight(height); };
	WORD left() const { return GTStringC::left(); };
	WORD top() const { return GTStringC::top(); };
	WORD width() const { return GTStringC::width(); };
	WORD height() const { return GTStringC::height(); };
	WORD leftBorder() const { return GTStringC::leftBorder(); };
	WORD topBorder() const { return GTStringC::topBorder(); };
	WORD rightBorder() const { return GTStringC::rightBorder(); };
	WORD bottomBorder() const { return GTStringC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTStringC::disable(value); };
	BOOL isDisabled() const { return GTStringC::isDisabled(); };
	BOOL activate(BOOL value) { return GTStringC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTStringC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTStringC::setDefTextAttr(t); };
	ULONG idcmp() { return GTStringC::idcmp(); };
	VOID set(STRPTR s) { GTStringC::set(s); };
	STRPTR get() { return GTStringC::get(); };
	VOID setInnerBorderWidth(WORD w) { innerBorderWidth = w; };
	VOID setInnerBorderHeight(WORD h) { innerBorderHeight = h; };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	WORD innerBorderHeight;
	WORD innerBorderWidth;
	WORD stringColumns;
	BOOL aWidth;
	BOOL aHeight;
};

class LGTIntegerC : public GTIntegerC, public LGIntegerC {
public:
	LGTIntegerC(GadgetEventC *,
		WORD columns = LAYOUT_AUTOSIZE, STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTIntegerC(GadgetEventC *,
		WORD columns, STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTIntegerC::rebuild(prev); };
	VOID erase(WindowC *w) { GTIntegerC::erase(w); };
	VOID setLeft(WORD left) { GTIntegerC::setLeft(left); };
	VOID setTop(WORD top) { GTIntegerC::setTop(top); };
	VOID setWidth(WORD width) { GTIntegerC::setWidth(width); };
	VOID setHeight(WORD height) { GTIntegerC::setHeight(height); };
	WORD left() const { return GTIntegerC::left(); };
	WORD top() const { return GTIntegerC::top(); };
	WORD width() const { return GTIntegerC::width(); };
	WORD height() const { return GTIntegerC::height(); };
	WORD leftBorder() const { return GTIntegerC::leftBorder(); };
	WORD topBorder() const { return GTIntegerC::topBorder(); };
	WORD rightBorder() const { return GTIntegerC::rightBorder(); };
	WORD bottomBorder() const { return GTIntegerC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTIntegerC::disable(value); };
	BOOL isDisabled() const { return GTIntegerC::isDisabled(); };
	BOOL activate(BOOL value) { return GTIntegerC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTIntegerC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTIntegerC::setDefTextAttr(t); };
	ULONG idcmp() { return GTIntegerC::idcmp(); };
	VOID set(LONG l) { GTIntegerC::set(l); };
	LONG get() { return GTIntegerC::get(); };
	VOID setInnerBorderWidth(WORD w) { innerBorderWidth = w; };
	VOID setInnerBorderHeight(WORD h) { innerBorderHeight = h; };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	WORD innerBorderHeight;
	WORD innerBorderWidth;
	WORD stringColumns;
	BOOL aWidth;
	BOOL aHeight;
};

class LGTCheckboxC : public GTCheckboxC, public LGCheckboxC {
public:
	LGTCheckboxC(GadgetEventC *,
		STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTCheckboxC(GadgetEventC *,
		STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTCheckboxC::rebuild(prev); };
	VOID erase(WindowC *w) { GTCheckboxC::erase(w); };
	VOID setLeft(WORD left) { GTCheckboxC::setLeft(left); };
	VOID setTop(WORD top) { GTCheckboxC::setTop(top); };
	VOID setWidth(WORD width) { GTCheckboxC::setWidth(width); };
	VOID setHeight(WORD height) { GTCheckboxC::setHeight(height); };
	WORD left() const { return GTCheckboxC::left(); };
	WORD top() const { return GTCheckboxC::top(); };
	WORD width() const { return GTCheckboxC::width(); };
	WORD height() const { return GTCheckboxC::height(); };
	WORD leftBorder() const { return GTCheckboxC::leftBorder(); };
	WORD topBorder() const { return GTCheckboxC::topBorder(); };
	WORD rightBorder() const { return GTCheckboxC::rightBorder(); };
	WORD bottomBorder() const { return GTCheckboxC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTCheckboxC::disable(value); };
	BOOL isDisabled() const { return GTCheckboxC::isDisabled(); };
	BOOL activate(BOOL value) { return GTCheckboxC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTCheckboxC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTCheckboxC::setDefTextAttr(t); };
	ULONG idcmp() { return GTCheckboxC::idcmp(); };
	VOID check(BOOL b) { GTCheckboxC::check(b); };
	BOOL checked() { return GTCheckboxC::checked(); };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LGTRadioC : public GTRadioC, public LGRadioC {
public:
	LGTRadioC(GadgetEventC *,
		stringarray &buttonlabels,
		ULONG place = 0, STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL,
		UWORD id = 0, struct TagItem *taglist = NULL);
	LGTRadioC(GadgetEventC *,
		stringarray &buttonlabels,
		ULONG place, STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTRadioC::rebuild(prev); };
	VOID erase(WindowC *w) { GTRadioC::erase(w); };
	VOID setLeft(WORD left) { GTRadioC::setLeft(left); };
	VOID setTop(WORD top) { GTRadioC::setTop(top); };
	VOID setWidth(WORD width) { GTRadioC::setWidth(width); };
	VOID setHeight(WORD height) { GTRadioC::setHeight(height); };
	WORD left() const { return GTRadioC::left(); };
	WORD top() const { return GTRadioC::top(); };
	WORD width() const { return GTRadioC::width(); };
	WORD height() const { return GTRadioC::height(); };
	WORD leftBorder() const { return GTRadioC::leftBorder(); };
	WORD topBorder() const { return GTRadioC::topBorder(); };
	WORD rightBorder() const { return GTRadioC::rightBorder(); };
	WORD bottomBorder() const { return GTRadioC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTRadioC::disable(value); };
	BOOL isDisabled() const { return GTRadioC::isDisabled(); };
	BOOL activate(BOOL value) { return GTRadioC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTRadioC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTRadioC::setDefTextAttr(t); };
	ULONG idcmp() { return GTRadioC::idcmp(); };
	VOID select(ULONG s) { GTRadioC::select(s); };
	ULONG selected() { return GTRadioC::selected(); };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LGTCycleC : public GTCycleC, public LGCycleC {
public:
	LGTCycleC(GadgetEventC *,
		stringarray &cyclelabels,
		STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTCycleC(GadgetEventC *,
		stringarray &cyclelabels,
		STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTCycleC::rebuild(prev); };
	VOID erase(WindowC *w) { GTCycleC::erase(w); };
	VOID setLeft(WORD left) { GTCycleC::setLeft(left); };
	VOID setTop(WORD top) { GTCycleC::setTop(top); };
	VOID setWidth(WORD width) { GTCycleC::setWidth(width); };
	VOID setHeight(WORD height) { GTCycleC::setHeight(height); };
	WORD left() const { return GTCycleC::left(); };
	WORD top() const { return GTCycleC::top(); };
	WORD width() const { return GTCycleC::width(); };
	WORD height() const { return GTCycleC::height(); };
	WORD leftBorder() const { return GTCycleC::leftBorder(); };
	WORD topBorder() const { return GTCycleC::topBorder(); };
	WORD rightBorder() const { return GTCycleC::rightBorder(); };
	WORD bottomBorder() const { return GTCycleC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTCycleC::disable(value); };
	BOOL isDisabled() const { return GTCycleC::isDisabled(); };
	BOOL activate(BOOL value) { return GTCycleC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTCycleC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTCycleC::setDefTextAttr(t); };
	ULONG idcmp() { return GTCycleC::idcmp(); };
	VOID select(ULONG s) { GTCycleC::select(s); };
	ULONG selected() { return GTCycleC::selected(); };
	VOID setLabels(STRPTR *labels) { GTCycleC::setLabels(labels); };
	VOID setLabels(STRPTR label1, ...) { GTCycleC::setLabels(&label1); };
	STRPTR *getLabels() { return GTCycleC::getLabels(); };
	ULONG labelsCount() { return GTCycleC::labelsCount(); };
	UWORD addLabel(STRPTR label) { return GTCycleC::addLabel(label); };
	VOID remLabel(UWORD count) { GTCycleC::remLabel(count); };
	VOID setInnerBorderWidth(WORD w) { innerBorderWidth = w; };
	VOID setInnerBorderHeight(WORD h) { innerBorderHeight = h; };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	WORD innerBorderHeight;
	WORD innerBorderWidth;
	BOOL aWidth;
	BOOL aHeight;
};

class LGTSliderC : public GTSliderC, public LGSliderC {
public:
	LGTSliderC(GadgetEventC *,
		STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTSliderC(GadgetEventC *,
		STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTSliderC::rebuild(prev); };
	VOID erase(WindowC *w) { GTSliderC::erase(w); };
	VOID setLeft(WORD left) { GTSliderC::setLeft(left); };
	VOID setTop(WORD top) { GTSliderC::setTop(top); };
	VOID setWidth(WORD width) { GTSliderC::setWidth(width); };
	VOID setHeight(WORD height) { GTSliderC::setHeight(height); };
	WORD left() const { return GTSliderC::left(); };
	WORD top() const { return GTSliderC::top(); };
	WORD width() const { return GTSliderC::width(); };
	WORD height() const { return GTSliderC::height(); };
	WORD leftBorder() const { return GTSliderC::leftBorder(); };
	WORD topBorder() const { return GTSliderC::topBorder(); };
	WORD rightBorder() const { return GTSliderC::rightBorder(); };
	WORD bottomBorder() const { return GTSliderC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTSliderC::disable(value); };
	BOOL isDisabled() const { return GTSliderC::isDisabled(); };
	BOOL activate(BOOL value) { return GTSliderC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTSliderC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTSliderC::setDefTextAttr(t); };
	ULONG idcmp() { return GTSliderC::idcmp(); };
	VOID setMin(UWORD m) { GTSliderC::setMin(m); };
	VOID setMax(UWORD m) { GTSliderC::setMax(m); };
	VOID setLevel(UWORD l) { GTSliderC::setLevel(l); };
	UWORD min() { return GTSliderC::min(); };
	UWORD max() { return GTSliderC::max(); };
	UWORD level() { return GTSliderC::level(); };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LGTScrollerC : public GTScrollerC, public LGScrollerC {
public:
	LGTScrollerC(GadgetEventC *,
		STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTScrollerC(GadgetEventC *,
		STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTScrollerC::rebuild(prev); };
	VOID erase(WindowC *w) { GTScrollerC::erase(w); };
	VOID setLeft(WORD left) { GTScrollerC::setLeft(left); };
	VOID setTop(WORD top) { GTScrollerC::setTop(top); };
	VOID setWidth(WORD width) { GTScrollerC::setWidth(width); };
	VOID setHeight(WORD height) { GTScrollerC::setHeight(height); };
	WORD left() const { return GTScrollerC::left(); };
	WORD top() const { return GTScrollerC::top(); };
	WORD width() const { return GTScrollerC::width(); };
	WORD height() const { return GTScrollerC::height(); };
	WORD leftBorder() const { return GTScrollerC::leftBorder(); };
	WORD topBorder() const { return GTScrollerC::topBorder(); };
	WORD rightBorder() const { return GTScrollerC::rightBorder(); };
	WORD bottomBorder() const { return GTScrollerC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTScrollerC::disable(value); };
	BOOL isDisabled() const { return GTScrollerC::isDisabled(); };
	BOOL activate(BOOL value) { return GTScrollerC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTScrollerC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTScrollerC::setDefTextAttr(t); };
	ULONG idcmp() { return GTScrollerC::idcmp(); };
	VOID setPot(UWORD p) { GTScrollerC::setPot(p); };
	VOID setTotal(UWORD t) { GTScrollerC::setTotal(t); };
	VOID setVisible(UWORD v) { GTScrollerC::setVisible(v); };
	UWORD pot() { return GTScrollerC::pot(); };
	UWORD total() { return GTScrollerC::total(); };
	UWORD visible() { return GTScrollerC::visible(); };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LGTListviewC : public GTListviewC, public LGListviewC {
public:
	LGTListviewC(GadgetEventC *,
		WORD entries = LAYOUT_AUTOSIZE, STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTListviewC(GadgetEventC *,
		WORD entries, STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTListviewC::rebuild(prev); };
	VOID erase(WindowC *w) { GTListviewC::erase(w); };
	VOID setLeft(WORD left) { GTListviewC::setLeft(left); };
	VOID setTop(WORD top) { GTListviewC::setTop(top); };
	VOID setWidth(WORD width) { GTListviewC::setWidth(width); };
	VOID setHeight(WORD height) { GTListviewC::setHeight(height); };
	WORD left() const { return GTListviewC::left(); };
	WORD top() const { return GTListviewC::top(); };
	WORD width() const { return GTListviewC::width(); };
	WORD height() const { return GTListviewC::height(); };
	WORD leftBorder() const { return GTListviewC::leftBorder(); };
	WORD topBorder() const { return GTListviewC::topBorder(); };
	WORD rightBorder() const { return GTListviewC::rightBorder(); };
	WORD bottomBorder() const { return GTListviewC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTListviewC::disable(value); };
	BOOL isDisabled() const { return GTListviewC::isDisabled(); };
	BOOL activate(BOOL value) { return GTListviewC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTListviewC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTListviewC::setDefTextAttr(t); };
	ULONG idcmp() { return GTListviewC::idcmp(); };
	VOID select(ULONG s) { GTListviewC::select(s); };
	ULONG selected() { return GTListviewC::selected(); };
	VOID clearSelection() { GTListviewC::clearSelection(); };
	VOID setList(EListC *header) { GTListviewC::setList(header); };
	EListC *getList() { return GTListviewC::getList(); };
	VOID detachList() { GTListviewC::detachList(); };
	VOID attachList() { GTListviewC::attachList(); };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	WORD listEntries;
	BOOL aWidth;
	BOOL aHeight;
};

class LGTPaletteC : public GTPaletteC, public LGPaletteC {
public:
	LGTPaletteC(GadgetEventC *,
		STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTPaletteC(GadgetEventC *,
		STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTPaletteC::rebuild(prev); };
	VOID erase(WindowC *w) { GTPaletteC::erase(w); };
	VOID setLeft(WORD left) { GTPaletteC::setLeft(left); };
	VOID setTop(WORD top) { GTPaletteC::setTop(top); };
	VOID setWidth(WORD width) { GTPaletteC::setWidth(width); };
	VOID setHeight(WORD height) { GTPaletteC::setHeight(height); };
	WORD left() const { return GTPaletteC::left(); };
	WORD top() const { return GTPaletteC::top(); };
	WORD width() const { return GTPaletteC::width(); };
	WORD height() const { return GTPaletteC::height(); };
	WORD leftBorder() const { return GTPaletteC::leftBorder(); };
	WORD topBorder() const { return GTPaletteC::topBorder(); };
	WORD rightBorder() const { return GTPaletteC::rightBorder(); };
	WORD bottomBorder() const { return GTPaletteC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTPaletteC::disable(value); };
	BOOL isDisabled() const { return GTPaletteC::isDisabled(); };
	BOOL activate(BOOL value) { return GTPaletteC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTPaletteC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTPaletteC::setDefTextAttr(t); };
	ULONG idcmp() { return GTPaletteC::idcmp(); };
	VOID select(ULONG l) { GTPaletteC::select(l); };
	ULONG selected() { return GTPaletteC::selected(); };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	BOOL aWidth;
	BOOL aHeight;
};

class LGTTextC : public GTTextC, public LGTextC {
public:
	LGTTextC(GadgetEventC * = NULL,
		WORD columns = LAYOUT_AUTOSIZE, STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTTextC(GadgetEventC *,
		WORD columns, STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTTextC::rebuild(prev); };
	VOID erase(WindowC *w) { GTTextC::erase(w); };
	VOID setLeft(WORD left) { GTTextC::setLeft(left); };
	VOID setTop(WORD top) { GTTextC::setTop(top); };
	VOID setWidth(WORD width) { GTTextC::setWidth(width); };
	VOID setHeight(WORD height) { GTTextC::setHeight(height); };
	WORD left() const { return GTTextC::left(); };
	WORD top() const { return GTTextC::top(); };
	WORD width() const { return GTTextC::width(); };
	WORD height() const { return GTTextC::height(); };
	WORD leftBorder() const { return GTTextC::leftBorder(); };
	WORD topBorder() const { return GTTextC::topBorder(); };
	WORD rightBorder() const { return GTTextC::rightBorder(); };
	WORD bottomBorder() const { return GTTextC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTTextC::disable(value); };
	BOOL isDisabled() const { return GTTextC::isDisabled(); };
	BOOL activate(BOOL value) { return GTTextC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTTextC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTTextC::setDefTextAttr(t); };
	ULONG idcmp() { return GTTextC::idcmp(); };
	VOID set(STRPTR s) { GTTextC::set(s); };
	STRPTR get() { return GTTextC::get(); };
	VOID setInnerBorderWidth(WORD w) { innerBorderWidth = w; };
	VOID setInnerBorderHeight(WORD h) { innerBorderHeight = h; };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	WORD innerBorderHeight;
	WORD innerBorderWidth;
	WORD textColumns;
	BOOL aWidth;
	BOOL aHeight;
};

class LGTNumberC : public GTNumberC, public LGNumberC {
public:
	LGTNumberC(GadgetEventC *,
		WORD columns = LAYOUT_AUTOSIZE, STRPTR label = NULL,
		WORD Width = LAYOUT_AUTOSIZE, WORD Height = LAYOUT_AUTOSIZE,
		ULONG flags = 0, const TextAttrC * = NULL, UWORD id = 0,
		struct TagItem *taglist = NULL);
	LGTNumberC(GadgetEventC *,
		WORD columns, STRPTR label, WORD Width, WORD Height,
		ULONG flags, const TextAttrC *, UWORD id,
		Tag tag1type, ...);
	struct Gadget *rebuild(struct Gadget *prev) { return GTNumberC::rebuild(prev); };
	VOID erase(WindowC *w) { GTNumberC::erase(w); };
	VOID setLeft(WORD left) { GTNumberC::setLeft(left); };
	VOID setTop(WORD top) { GTNumberC::setTop(top); };
	VOID setWidth(WORD width) { GTNumberC::setWidth(width); };
	VOID setHeight(WORD height) { GTNumberC::setHeight(height); };
	WORD left() const { return GTNumberC::left(); };
	WORD top() const { return GTNumberC::top(); };
	WORD width() const { return GTNumberC::width(); };
	WORD height() const { return GTNumberC::height(); };
	WORD leftBorder() const { return GTNumberC::leftBorder(); };
	WORD topBorder() const { return GTNumberC::topBorder(); };
	WORD rightBorder() const { return GTNumberC::rightBorder(); };
	WORD bottomBorder() const { return GTNumberC::bottomBorder(); };
	BOOL disable(BOOL value) { return GTNumberC::disable(value); };
	BOOL isDisabled() const { return GTNumberC::isDisabled(); };
	BOOL activate(BOOL value) { return GTNumberC::activate(value); };
	VOID setTextAttr(const TextAttrC *t) { GTNumberC::setTextAttr(t); };
	VOID setDefTextAttr(const TextAttrC *t) { GTNumberC::setDefTextAttr(t); };
	ULONG idcmp() { return GTNumberC::idcmp(); };
	VOID set(LONG l) { GTNumberC::set(l); };
	LONG get() { return GTNumberC::get(); };
	VOID setInnerBorderWidth(WORD w) { innerBorderWidth = w; };
	VOID setInnerBorderHeight(WORD h) { innerBorderHeight = h; };
	BOOL layoutWidth();
	BOOL layoutHeight();
	BOOL autoWidth() const { return aWidth; };
	BOOL autoHeight() const { return aHeight; };
private:
	WORD innerBorderHeight;
	WORD innerBorderWidth;
	WORD textColumns;
	BOOL aWidth;
	BOOL aHeight;
};

#endif
